Index: trunk/branches/Build.cmd
===================================================================
--- trunk/branches/Build.cmd	(revision 7526)
+++ trunk/branches/Build.cmd	(revision 7526)
@@ -0,0 +1,94 @@
+@ECHO OFF
+
+SET CLEANBEFOREBUILD=0
+
+SET SELECTED=
+SET CONFIGURATION=
+SET PLATFORM=
+
+IF "%~1"=="" GOTO :prompt_solution
+
+SET SELECTED=%1
+IF NOT EXIST %SELECTED% (
+  ECHO Solution file %SELECTED% could not be found.
+  GOTO :end
+)
+ECHO Building solution %SELECTED% ...
+GOTO :config_selection
+
+:prompt_solution
+SET /A COUNT=0
+FOR /F "tokens=*" %%A IN ('dir /B *.sln') DO (
+  CALL :forloopbody "%%A"
+)
+
+IF "%COUNT%"=="1" (
+  SET SELECTED=%SOLUTIONS.1%
+  ECHO Building %SOLUTIONS.1% as it is the only solution that was found ...
+  GOTO :config_selection
+)
+
+ECHO Found the following solutions:
+FOR /F "tokens=2* delims=.=" %%A IN ('SET SOLUTIONS.') DO ECHO %%A = %%B
+ECHO.
+SET /P SOLUTIONINDEX=Which solution to build? Type the number: 
+
+SET SELECTED=""
+FOR /F "tokens=2* delims=.=" %%A IN ('SET SOLUTIONS.') DO (
+  IF "%%A"=="%SOLUTIONINDEX%" SET SELECTED=%%B
+)
+
+IF %SELECTED%=="" GOTO :eof
+
+:config_selection
+IF "%~2"==""  GOTO :prompt_config
+
+SET CONFIGURATION=%~2
+ECHO Building configuration %CONFIGURATION% ...
+GOTO :platform_selection
+
+:prompt_config
+SET /P CONFIGURATION=Which configuration to build [Release]: 
+IF "%CONFIGURATION%"=="" SET CONFIGURATION=Release
+
+:platform_selection
+IF "%~3"=="" GOTO :prompt_platform
+  
+SET PLATFORM=%~3
+ECHO Building platform %PLATFORM% ...
+GOTO :main
+
+:prompt_platform
+SET /P PLATFORM=Which platform to build [Any CPU]: 
+IF "%PLATFORM%"=="" SET PLATFORM=Any CPU
+
+:main
+REM First find the path to the msbuild.exe by performing a registry query
+FOR /F "tokens=1,3 delims=	 " %%A IN ('REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\MSBuild\ToolsVersions\4.0"') DO (
+  IF "%%A"=="MSBuildToolsPath" SET MSBUILDPATH=%%B)
+
+REM Then execute msbuild to clean and build the solution
+REM Disable that msbuild creates a cache file of the solution
+SET MSBuildUseNoSolutionCache=1
+REM Run msbuild to clean and then build
+IF "%CLEANBEFOREBUILD%"=="1" (
+  ECHO Cleaning ...
+  %MSBUILDPATH%msbuild.exe %SELECTED% /target:Clean /p:Configuration="%CONFIGURATION%",Platform="%PLATFORM%" /m:2 /nologo /verbosity:q /clp:ErrorsOnly
+)
+ECHO Building ...
+%MSBUILDPATH%msbuild.exe %SELECTED% /target:Rebuild /p:Configuration="%CONFIGURATION%",Platform="%PLATFORM%" /m:2 /nologo /verbosity:q /clp:ErrorsOnly
+
+ECHO.
+ECHO DONE.
+
+:end
+
+PAUSE
+
+GOTO :eof
+
+REM This workaround is necessary so that COUNT gets reevaluated
+:forloopbody
+SET /A COUNT+=1
+SET SOLUTIONS.%COUNT%=%1
+GOTO :eof
Index: trunk/branches/HeuristicLab.Optimizer.Tools/3.3/HeuristicLab.Optimizer.Tools-3.3.csproj
===================================================================
--- trunk/branches/HeuristicLab.Optimizer.Tools/3.3/HeuristicLab.Optimizer.Tools-3.3.csproj	(revision 7526)
+++ trunk/branches/HeuristicLab.Optimizer.Tools/3.3/HeuristicLab.Optimizer.Tools-3.3.csproj	(revision 7526)
@@ -0,0 +1,129 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>8.0.30703</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{2C525B2C-CE72-4822-9AF3-CE5B9FA8EF0C}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Optimizer.Tools</RootNamespace>
+    <AssemblyName>HeuristicLab.Optimizer.Tools-3.3</AssemblyName>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="ALGLIB-3.4.0, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Core.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Data.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.MainForm-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.MainForm.WindowsForms-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Optimizer-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Windows.Forms" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="MDSView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="MDSView.Designer.cs">
+      <DependentUpon>MDSView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="MultidimensionalScalingMenuItem.cs" />
+    <None Include="Plugin.cs.frame" />
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="MDSView.resx">
+      <DependentUpon>MDSView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+REM call PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MDSView.Designer.cs
===================================================================
--- trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MDSView.Designer.cs	(revision 7526)
+++ trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MDSView.Designer.cs	(revision 7526)
@@ -0,0 +1,115 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Optimizer.Tools {
+  partial class MDSView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.visualizeCheckBox = new System.Windows.Forms.CheckBox();
+      this.mdsPictureBox = new System.Windows.Forms.PictureBox();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.mdsPictureBox)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // rowsTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.rowsTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.rowsTextBox, 2);
+      this.rowsTextBox.Size = new System.Drawing.Size(282, 20);
+      // 
+      // columnsTextBox
+      // 
+      this.columnsTextBox.Size = new System.Drawing.Size(282, 20);
+      // 
+      // visualizeCheckBox
+      // 
+      this.visualizeCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.visualizeCheckBox.Appearance = System.Windows.Forms.Appearance.Button;
+      this.visualizeCheckBox.Location = new System.Drawing.Point(353, 0);
+      this.visualizeCheckBox.Name = "visualizeCheckBox";
+      this.visualizeCheckBox.Size = new System.Drawing.Size(71, 46);
+      this.visualizeCheckBox.TabIndex = 7;
+      this.visualizeCheckBox.Text = "Visualize";
+      this.visualizeCheckBox.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
+      this.visualizeCheckBox.UseVisualStyleBackColor = true;
+      this.visualizeCheckBox.CheckedChanged += new System.EventHandler(this.visualizeCheckBox_CheckedChanged);
+      // 
+      // mdsPictureBox
+      // 
+      this.mdsPictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.mdsPictureBox.Location = new System.Drawing.Point(0, 52);
+      this.mdsPictureBox.Name = "mdsPictureBox";
+      this.mdsPictureBox.Size = new System.Drawing.Size(424, 333);
+      this.mdsPictureBox.TabIndex = 8;
+      this.mdsPictureBox.TabStop = false;
+      this.mdsPictureBox.Visible = false;
+      // 
+      // MDSView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.mdsPictureBox);
+      this.Controls.Add(this.visualizeCheckBox);
+      this.Name = "MDSView";
+      this.Controls.SetChildIndex(this.visualizeCheckBox, 0);
+      this.Controls.SetChildIndex(this.mdsPictureBox, 0);
+      this.Controls.SetChildIndex(this.statisticsTextBox, 0);
+      this.Controls.SetChildIndex(this.rowsLabel, 0);
+      this.Controls.SetChildIndex(this.columnsLabel, 0);
+      this.Controls.SetChildIndex(this.rowsTextBox, 0);
+      this.Controls.SetChildIndex(this.columnsTextBox, 0);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      ((System.ComponentModel.ISupportInitialize)(this.mdsPictureBox)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.CheckBox visualizeCheckBox;
+    private System.Windows.Forms.PictureBox mdsPictureBox;
+
+  }
+}
Index: trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MDSView.cs
===================================================================
--- trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MDSView.cs	(revision 7526)
+++ trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MDSView.cs	(revision 7526)
@@ -0,0 +1,200 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using System.Globalization;
+using System.Text;
+using System.Text.RegularExpressions;
+using HeuristicLab.Analysis;
+using HeuristicLab.Data;
+using HeuristicLab.Data.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Optimizer.Tools {
+  [View("MDSView")]
+  [Content(typeof(IStringConvertibleMatrix), IsDefaultView = false)]
+  public partial class MDSView : StringConvertibleMatrixView {
+
+    public MDSView() {
+      InitializeComponent();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.RowsChanged += new EventHandler(Content_Changed);
+      Content.ColumnsChanged += new EventHandler(Content_Changed);
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.RowsChanged -= new EventHandler(Content_Changed);
+      Content.ColumnsChanged -= new EventHandler(Content_Changed);
+      base.DeregisterContentEvents();
+    }
+
+    private void Content_Changed(object sender, EventArgs e) {
+      SetEnabledStateOfControls();
+      OnRedraw();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      OnRedraw();
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      visualizeCheckBox.Enabled = Content != null && Content.Rows == Content.Columns && Content.Rows > 0;
+      mdsPictureBox.Visible = visualizeCheckBox.Enabled && visualizeCheckBox.Checked;
+    }
+
+    private void visualizeCheckBox_CheckedChanged(object sender, System.EventArgs e) {
+      mdsPictureBox.Visible = visualizeCheckBox.Checked;
+      OnRedraw();
+    }
+
+    private void OnRedraw() {
+      if (InvokeRequired) {
+        Invoke((Action)OnRedraw, null);
+      } else {
+        if (!mdsPictureBox.Visible) return;
+        GenerateImage();
+      }
+    }
+
+    private void GenerateImage() {
+      if (Content.Rows == Content.Columns && Content.Rows > 0
+       && mdsPictureBox.Width > 0 && mdsPictureBox.Height > 0) {
+        Bitmap newBitmap = GenerateDistanceImage();
+        if (newBitmap != null) {
+          var oldImage = mdsPictureBox.Image;
+          mdsPictureBox.Image = newBitmap;
+          if (oldImage != null) oldImage.Dispose();
+        }
+      }
+    }
+
+    private Bitmap GenerateDistanceImage() {
+      Bitmap newBitmap = new Bitmap(mdsPictureBox.Width, mdsPictureBox.Height);
+
+      DoubleMatrix coordinates;
+      double stress = double.NaN;
+      DoubleMatrix matrix = new DoubleMatrix(Content.Rows, Content.Columns, Content.ColumnNames, Content.RowNames);
+      try {
+        for (int i = 0; i < Content.Rows; i++)
+          for (int j = 0; j < Content.Columns; j++)
+            matrix[i, j] = double.Parse(Content.GetValue(i, j));
+        coordinates = MultidimensionalScaling.KruskalShepard(matrix);
+        stress = MultidimensionalScaling.CalculateNormalizedStress(matrix, coordinates);
+        statisticsTextBox.Text = "Stress: " + stress.ToString("0.00", CultureInfo.CurrentCulture.NumberFormat);
+      } catch {
+        WriteCenteredTextToBitmap(ref newBitmap, "Matrix is not symmetric");
+        statisticsTextBox.Text = "-";
+        return newBitmap;
+      }
+      double xMin = double.MaxValue, yMin = double.MaxValue, xMax = double.MinValue, yMax = double.MinValue;
+      double maxDistance = double.MinValue;
+      for (int i = 0; i < coordinates.Rows; i++) {
+        if (xMin > coordinates[i, 0]) xMin = coordinates[i, 0];
+        if (yMin > coordinates[i, 1]) yMin = coordinates[i, 1];
+        if (xMax < coordinates[i, 0]) xMax = coordinates[i, 0];
+        if (yMax < coordinates[i, 1]) yMax = coordinates[i, 1];
+
+        for (int j = i + 1; j < coordinates.Rows; j++) {
+          if (matrix[i, j] > maxDistance) maxDistance = matrix[i, j];
+          if (matrix[j, i] > maxDistance) maxDistance = matrix[j, i];
+        }
+      }
+
+      int border = 20;
+      double xStep = xMax != xMin ? (mdsPictureBox.Width - 2 * border) / (xMax - xMin) : 1;
+      double yStep = yMax != yMin ? (mdsPictureBox.Height - 2 * border) / (yMax - yMin) : 1;
+
+      Point[] points = new Point[coordinates.Rows];
+      for (int i = 0; i < coordinates.Rows; i++)
+        points[i] = new Point(border + ((int)((coordinates[i, 0] - xMin) * xStep)),
+                              newBitmap.Height - (border + ((int)((coordinates[i, 1] - yMin) * yStep))));
+
+      Random rand = new Random();
+      using (Graphics graphics = Graphics.FromImage(newBitmap)) {
+        graphics.Clear(Color.White);
+        graphics.DrawString("Showing entities spaced out according to their distances.", Font, Brushes.Black, 5, 2);
+
+        for (int i = 0; i < coordinates.Rows - 1; i++) {
+          for (int j = i + 1; j < coordinates.Rows; j++) {
+            Point start = points[i], end = points[j];
+            string caption = String.Empty;
+            double d = Math.Max(matrix[i, j], matrix[j, i]);
+            float width = (float)Math.Ceiling(5.0 * d / maxDistance);
+            if (d > 0) {
+              graphics.DrawLine(new Pen(Color.IndianRed, width), start, end);
+              if (matrix[i, j] != matrix[j, i])
+                caption = matrix[i, j].ToString(CultureInfo.InvariantCulture.NumberFormat)
+                  + " / " + matrix[j, i].ToString(CultureInfo.InvariantCulture.NumberFormat);
+              else
+                caption = matrix[i, j].ToString(CultureInfo.InvariantCulture.NumberFormat);
+            }
+            if (!String.IsNullOrEmpty(caption)) {
+              double r = rand.NextDouble();
+              while (r < 0.2 || r > 0.8) r = rand.NextDouble();
+              float x = (float)(start.X + (end.X - start.X) * r + 5);
+              float y = (float)(start.Y + (end.Y - start.Y) * r + 5);
+              graphics.DrawString(caption, Font, Brushes.Black, x, y);
+            }
+          }
+        }
+
+        for (int i = 0; i < points.Length; i++) {
+          Point p = new Point(points[i].X - 3, points[i].Y - 3);
+          graphics.FillRectangle(Brushes.Black, p.X, p.Y, 8, 8);
+          graphics.DrawString(i.ToString(), Font, Brushes.Black, p.X, p.Y + 10);
+        }
+      }
+      return newBitmap;
+    }
+
+    private void WriteCenteredTextToBitmap(ref Bitmap bitmap, string text) {
+      if (bitmap == null) return;
+      using (Graphics g = Graphics.FromImage(bitmap)) {
+        g.Clear(Color.White);
+
+        Font font = new Font(FontFamily.GenericSansSerif, 12, FontStyle.Regular);
+        SizeF strSize = g.MeasureString(text, font);
+        if (strSize.Width + 50 > mdsPictureBox.Width) {
+          var m = Regex.Match(text, @"\b\w+[.,]*\b*");
+          var builder = new StringBuilder();
+          while (m.Success) {
+            builder.Append(m.Value + " ");
+            Match next = m.NextMatch();
+            if (g.MeasureString(builder.ToString() + " " + next.Value, font).Width + 50 > mdsPictureBox.Width)
+              builder.AppendLine();
+            m = next;
+          }
+          builder.Remove(builder.Length - 1, 1);
+          text = builder.ToString();
+          strSize = g.MeasureString(text, font);
+        }
+        g.DrawString(text, font, Brushes.Black, (float)(mdsPictureBox.Width - strSize.Width) / 2.0f, (float)(mdsPictureBox.Height - strSize.Height) / 2.0f);
+      }
+    }
+  }
+}
Index: trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MDSView.resx
===================================================================
--- trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MDSView.resx	(revision 7526)
+++ trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MDSView.resx	(revision 7526)
@@ -0,0 +1,123 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <metadata name="errorProvider.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>141, 17</value>
+  </metadata>
+</root>
Index: trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MultidimensionalScalingMenuItem.cs
===================================================================
--- trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MultidimensionalScalingMenuItem.cs	(revision 7526)
+++ trunk/branches/HeuristicLab.Optimizer.Tools/3.3/MultidimensionalScalingMenuItem.cs	(revision 7526)
@@ -0,0 +1,45 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Data;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Optimizer.Tools {
+  public class MultidimensionalScalingMenuItem : MenuItem, IOptimizerUserInterfaceItemProvider {
+    public override string Name {
+      get { return "Multidimensional Scaling"; }
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "Tools" }; }
+    }
+
+    public override int Position {
+      get { return 4101; }
+    }
+
+    public override void Execute() {
+      MainFormManager.MainForm.ShowContent(new DoubleMatrix(1, 1), typeof(MDSView));
+    }
+  }
+}
Index: trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Plugin.cs
===================================================================
--- trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Plugin.cs	(revision 7526)
+++ trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Plugin.cs	(revision 7526)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Optimizer.Tools {
+  [Plugin("HeuristicLab.Optimizer.Tools", "3.3.6.0")]
+  [PluginFile("HeuristicLab.Optimizer.Tools-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.ALGLIB", "3.4")]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Optimizer", "3.3")]
+  public class HeuristicLabOptimizerToolsPlugin : PluginBase { }
+}
Index: trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Plugin.cs.frame
===================================================================
--- trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Plugin.cs.frame	(revision 7526)
+++ trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Plugin.cs.frame	(revision 7526)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Optimizer.Tools {
+  [Plugin("HeuristicLab.Optimizer.Tools", "3.3.6.$WCREV$")]
+  [PluginFile("HeuristicLab.Optimizer.Tools-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.ALGLIB", "3.3")]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Optimizer", "3.3")]
+  public class HeuristicLabOptimizerToolsPlugin : PluginBase { }
+}
Index: trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Properties/AssemblyInfo.cs
===================================================================
--- trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Properties/AssemblyInfo.cs	(revision 7526)
+++ trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Properties/AssemblyInfo.cs	(revision 7526)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Optimizer.Tools")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("HEAL")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002 - 2012 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("5187a117-9d7c-484d-91f1-9fd27c323b0c")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.6.0")]
Index: trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Properties/AssemblyInfo.cs.frame	(revision 7526)
+++ trunk/branches/HeuristicLab.Optimizer.Tools/3.3/Properties/AssemblyInfo.cs.frame	(revision 7526)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Optimizer.Tools")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("HEAL")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002 - 2012 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("5187a117-9d7c-484d-91f1-9fd27c323b0c")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.6.$WCREV$")]
Index: trunk/branches/HeuristicLab.Optimizer.Tools/3.3/obj/Debug/HeuristicLab.Optimizer.Tools-3.3.csproj.FileListAbsolute.txt
===================================================================
--- trunk/branches/HeuristicLab.Optimizer.Tools/3.3/obj/Debug/HeuristicLab.Optimizer.Tools-3.3.csproj.FileListAbsolute.txt	(revision 7526)
+++ trunk/branches/HeuristicLab.Optimizer.Tools/3.3/obj/Debug/HeuristicLab.Optimizer.Tools-3.3.csproj.FileListAbsolute.txt	(revision 7526)
@@ -0,0 +1,8 @@
+C:\Users\Don\Work\HL3\trunk\sources\bin\HeuristicLab.Optimizer.Tools-3.3.dll
+C:\Users\Don\Work\HL3\trunk\sources\bin\HeuristicLab.Optimizer.Tools-3.3.pdb
+C:\Users\Don\Work\HL3\branches\OptimizerTools\HeuristicLab.Optimizer.Tools\3.3\obj\Debug\ResolveAssemblyReference.cache
+C:\Users\Don\Work\HL3\branches\OptimizerTools\HeuristicLab.Optimizer.Tools\3.3\obj\Debug\HeuristicLab.Optimizer.Tools-3.3.dll
+C:\Users\Don\Work\HL3\branches\OptimizerTools\HeuristicLab.Optimizer.Tools\3.3\obj\Debug\HeuristicLab.Optimizer.Tools-3.3.pdb
+C:\Users\Don\Work\HL3\branches\OptimizerTools\HeuristicLab.Optimizer.Tools\3.3\obj\Debug\HeuristicLab.Optimizer.Tools.MDSView.resources
+C:\Users\Don\Work\HL3\branches\OptimizerTools\HeuristicLab.Optimizer.Tools\3.3\obj\Debug\GenerateResource.read.1.tlog
+C:\Users\Don\Work\HL3\branches\OptimizerTools\HeuristicLab.Optimizer.Tools\3.3\obj\Debug\GenerateResource.write.1.tlog
Index: trunk/branches/OptimizerTools.sln
===================================================================
--- trunk/branches/OptimizerTools.sln	(revision 7526)
+++ trunk/branches/OptimizerTools.sln	(revision 7526)
@@ -0,0 +1,20 @@
+﻿
+Microsoft Visual Studio Solution File, Format Version 11.00
+# Visual Studio 2010
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Optimizer.Tools-3.3", "HeuristicLab.Optimizer.Tools\3.3\HeuristicLab.Optimizer.Tools-3.3.csproj", "{2C525B2C-CE72-4822-9AF3-CE5B9FA8EF0C}"
+EndProject
+Global
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Any CPU = Debug|Any CPU
+		Release|Any CPU = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{2C525B2C-CE72-4822-9AF3-CE5B9FA8EF0C}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{2C525B2C-CE72-4822-9AF3-CE5B9FA8EF0C}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{2C525B2C-CE72-4822-9AF3-CE5B9FA8EF0C}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{2C525B2C-CE72-4822-9AF3-CE5B9FA8EF0C}.Release|Any CPU.Build.0 = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
+	EndGlobalSection
+EndGlobal
Index: trunk/branches/PreBuildEvent.cmd
===================================================================
--- trunk/branches/PreBuildEvent.cmd	(revision 7526)
+++ trunk/branches/PreBuildEvent.cmd	(revision 7526)
@@ -0,0 +1,2 @@
+IF EXIST "%ProjectDir%\Properties\AssemblyInfo.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
+IF EXIST "%ProjectDir%\Plugin.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Plugin.cs.frame" "%ProjectDir%\Plugin.cs"
